from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String, File, Int

Caper_List_V0_1_0 = CommandToolBuilder(tool="caper_list", base_command=["caper", "list"], inputs=[ToolInput(tag="in_dry_run", input_type=Boolean(optional=True), prefix="--dry-run", doc=InputDocumentation(doc="Caper does not take any action.")), ToolInput(tag="in_debug", input_type=Boolean(optional=True), prefix="--debug", doc=InputDocumentation(doc="Prints all logs >= DEBUG level")), ToolInput(tag="in_port", input_type=String(optional=True), prefix="--port", doc=InputDocumentation(doc="Port for Caper server")), ToolInput(tag="in_ip", input_type=String(optional=True), prefix="--ip", doc=InputDocumentation(doc="IP address for Caper server")), ToolInput(tag="in_no_server_heartbeat", input_type=Boolean(optional=True), prefix="--no-server-heartbeat", doc=InputDocumentation(doc="Disable server heartbeat file.")), ToolInput(tag="in_server_heartbeat_file", input_type=File(optional=True), prefix="--server-heartbeat-file", doc=InputDocumentation(doc="Heartbeat file for Caper clients to get IP and port of\na server")), ToolInput(tag="in_server_heartbeat_timeout", input_type=File(optional=True), prefix="--server-heartbeat-timeout", doc=InputDocumentation(doc="Timeout for a heartbeat file in Milliseconds. A\nheartbeat file older than this interval will be\nignored.")), ToolInput(tag="in_format", input_type=String(optional=True), prefix="--format", doc=InputDocumentation(doc="Comma-separated list of items to be shown for 'list'\nsubcommand. Any key name in workflow JSON from\nCromwell server's response is allowed. Available keys\nare 'id' (workflow ID), 'status', 'str_label', 'name'\n(WDL/CWL name), 'submission' (date/time), 'start',\n'end' and 'user'. 'str_label' is a special key for\nCaper. See help context of '--str-label' for details")), ToolInput(tag="in_hide_result_before", input_type=Int(optional=True), prefix="--hide-result-before", doc=InputDocumentation(doc="Hide workflows submitted before this date/time. Use\nthe same (or shorter) date/time format shown in 'caper\nlist'. e.g. 2019-06-13, 2019-06-13T10:07")), ToolInput(tag="in_hide_sub_workflow", input_type=Boolean(optional=True), prefix="--hide-subworkflow", doc=InputDocumentation(doc="Hide subworkflows from 'caper list'.")), ToolInput(tag="in_wf_id_or_label", input_type=String(), position=0, doc=InputDocumentation(doc="List of workflow IDs to find matching workflows to\ncommit a specified action (list, metadata and abort).\nWildcards (* and ?) are allowed."))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Caper_List_V0_1_0().translate("wdl", allow_empty_container=True)

